      MODULE mod_biology
!
!svn $Id: mod_biology.F 375 2009-07-28 03:35:34Z arango $
!================================================== Hernan G. Arango ===
!  Copyright (c) 2002-2009 The ROMS/TOMS Group                         !
!    Licensed under a MIT/X style license                              !
!    See License_ROMS.txt                                              !
!=======================================================================
        USE mod_param
        implicit none
        integer, dimension(Ngrids) :: BioSeed
        integer, dimension(Ngrids) :: BioIter
        real(r8), dimension(Ngrids) :: PARfrac       ! nondimensional
!c NOTE: list not complete!!
!c mu = max growth rate (s-1)
!c ksat = half sat coeff, phyto specific for each nutrient
!c ksatlight = half sat coeff wrt light, phyto specific
!c graze = grazing rate, phyto specific for each zooplankton
!c mortzoo = mortality rate for each zooplankton
!c wsink = sinking speed, phyto specific
!c R_XY = stoichiometric ratios of nutrients in phytoplankton
!c        specific to each functional group, relative to Phos
!c physize = size class of phytoplankton; 0.0="small", 1.0="big"
!c diatom: 1.0 uses silica, 0.0 does not use silica
!c diazotrph: 1.0 fixes nitrogen, 0.0 does not fix nitrogen
!c zoosize = size class of zooplankton; 0.0="small", 1.0="big"
!c ExportFracZ(nzmax) = fraction of Z mortality sinking out:
!c                      rest remineralizes locally
!c Kpremin_xx = remin rate constant for particulate detritus
!c ngroups = tracks how many different "functional groups" of phyto
!c           have been tried
         INTEGER MAX_LEN_MBUF
         PARAMETER(MAX_LEN_MBUF=512)
         integer, allocatable :: PhytoSeeds(:) ! vector of phytoplankton numbers
         real(r8), allocatable :: mu(:)
         real(r8), allocatable :: ksatPO4(:)
         real(r8), allocatable :: ksatNO3(:)
         real(r8), allocatable :: ksatNO2(:)
         real(r8), allocatable :: ksatNH4(:)
         real(r8), allocatable :: ksatSi(:)
         real(r8), allocatable :: ksatFeT(:)
         real(r8), allocatable :: ksatPAR(:)
         real(r8), allocatable :: mortzoo(:)
         real(r8), allocatable :: wsink(:)
         real(r8), allocatable :: R_NP(:)
         real(r8), allocatable :: R_FeP(:)
         real(r8), allocatable :: R_SiP(:)
         real(r8), allocatable :: physize(:)
         real(r8), allocatable :: diatom(:)
         real(r8), allocatable :: diazotroph(:)
         real(r8), allocatable :: zoosize(:)
         real(r8), allocatable :: ExportFracZ(:)
         real(r8) Kpremin_P
         real(r8) Kpremin_N
         real(r8) Kpremin_Fe
         real(r8) Kpremin_Si
         real(r8), allocatable :: phytoTempCoeff(:)
         real(r8), allocatable :: phytoTempExp1(:)
         real(r8), allocatable :: phytoTempExp2(:)
         real(r8), allocatable :: phytoTempOptimum(:)
         real(r8), allocatable :: phytoDecayPower(:)
         real(r8), allocatable :: zooTempCoeff(:)
         real(r8), allocatable :: zooTempExp(:)
         real(r8), allocatable :: zooTempOptimum(:)
         real(r8) diatomgraz, olargegraz
         real(r8), allocatable :: kinhib(:)
         real(r8), allocatable :: mortphy(:)
         real(r8), allocatable :: ExportFracP(:)
         real(r8), allocatable :: sedPON(:,:)
         real(r8), allocatable :: sedPOP(:,:)
         real(r8), allocatable :: sedPOFe(:,:)
         real(r8), allocatable :: sedPOSi(:,:)
         real(r8) Smallgrow, Biggrow,Allgrow
         real(r8) Smallmort, Bigmort
         real(r8) Smallgrowrange, Biggrowrange, Allgrowrange
         real(r8) Smallmortrange, Bigmortrange
         real(r8) Smallexport, Bigexport
         real(r8) smallksatpar, smallksatparstd
         real(r8) smallkinhib, smallkinhibstd
         real(r8) tempcoeff1, tempcoeff2_big
         real(r8) tempcoeff2_small, tempcoeff3
         real(r8) tempmax, temprange, tempnorm,tempdecay
         real(r8) Bigksatpar, Bigksatparstd
         real(r8) Bigkinhib, Bigkinhibstd
         real(r8) SmallPsat, BigPsat, ProcPsat
         real(r8) SmallPsatrange, BigPsatrange, ProcPsatrange
         real(r8) prochlPsat
         real(r8) ksatNH4fac, ksatNO2fac
         real(r8) sig1,sig2,sig3
         real(r8) val_ksatsi
         real(r8), allocatable :: grazemax(:)
         real(r8), allocatable :: palat(:,:)
         real(r8), allocatable :: asseff(:,:)
         real(r8), allocatable :: kgrazesat(:)
         real(r8)  kgrazesatSmall, kgrazesatBig
         real(r8) GrazeEfflow, GrazeEffmod, GrazeEffhi,GrazeEffZoo
         real(r8) GrazeFast, GrazeSlow
         real(r8) palathi, palatmed,palatlo,palatzoo
         real(r8) phygrazmin,zoograzmin
         real(r8), allocatable :: ExportFracGraz(:)
         real(r8) ExGrazfracbig, ExGrazfracsmall
         real(r8) ZoomortSmall, ZoomortBig, ZooexfacSmall, ZooexfacBig
         real(r8) val_R_SiP_diatom, val_R_NP_diaz, val_RFeP_diaz,       &
     &          val_R_NP, val_RFeP
         real(r8) ngrowfac,ilight
         real(r8) phymin
         real(r8) PAR0
         real(r8) BiolocalMinN
         real(r8) BiolocalMinP
         real(r8) BiolocalMinSi
         real(r8) BiolocalMinFe
         INTEGER, allocatable :: nsource(:)
         INTEGER ngroups
         real(r8) wp_sink
         real(r8) wn_sink
         real(r8) wfe_sink
         real(r8) wsi_sink
         real(r8) Kdop
         real(r8) Kdon
         real(r8) KdoFe
         real(r8) SmallSink
         real(r8) BigSink
         real(r8) Knita
         real(r8) Knitb
         real(r8) :: diaz_growfac
         integer :: NPhytoSeeds
         integer :: PhytoIndexMax, nRegen
         integer, allocatable :: RegenPhyto(:)
         integer, allocatable :: PhytoIndex(:)
         integer, allocatable :: PhytoSeedPar(:)
         integer, allocatable :: PhytoSeedType(:)
         logical  :: loadPhytoFromINI
         real(r8) :: PThreshRegen
         real(r8) :: phytomaxmin, phytomaxmax
         integer :: kkmaxmin, kkmaxmax
         real(r8), allocatable :: phytomaxP(:)
!c    scav           - chemical scavenging rate for iron
!c    ligand_tot     - total organic ligand (assumed constant)
!c    ligand_stab    - ligand stability
!c    freefemax      - maximum free iron
         real(r8) alpfe, scav, ligand_tot, ligand_stab
         real(r8) freefemax
!c    k0, kc         - light coefficients
         real(r8) d_k0, d_kc
!c    chlpmax        - chl:p max ratio
!c    chlpmin        - chl:p min ratio
!c    istar          - photoadaptation light limit
         real(r8) chlpmax, chlpmin, istar
         integer idebug, jdebug, kdebug, ndebug
      CONTAINS
      SUBROUTINE allocate_biology (ng, LBi, UBi, LBj, UBj)
!
!=======================================================================
!                                                                      !
!  This routine allocates all variables in the module for all nested   !
!  grids.                                                              !
!                                                                      !
!=======================================================================
!
      USE mod_param
!
      implicit none
!  Local variable declarations.
!
      integer, intent(in) :: ng, LBi, UBi, LBj, UBj
!
!-----------------------------------------------------------------------
!  Allocate module variables.
!-----------------------------------------------------------------------
!
!
!  particulate sediment components
!
      allocate ( sedPON(LBi:UBi,LBj:UBj) )
      allocate ( sedPOP(LBi:UBi,LBj:UBj) )
      allocate ( sedPOSi(LBi:UBi,LBj:UBj) )
      END SUBROUTINE allocate_biology 
      END MODULE mod_biology
